{$A+,D-,I-,L-,R-,S-,V-}
{$M 8000,0,8000}

Program Config;
Uses Dispedit,
     DOS,
     TPCrt,
     TPString,
     TPDos,
     DosMem,
     MDosIO,
     BufIO,
     Tools,
     TPPick,
     TPHelp,
     ErrTrap;

const
title                            =  'NETMail   Version 4.3  ';
author                           = 'Copyright (c) 1989,90  Mark J. Findlay';
default_tcan_filename            = 'TCAN.NET';
default_help_filename            = 'NETMAIL.HLP';
default_cnames_dir               = 'C:\PCB\MAIN\CNAMES';
default_global_filename          = 'GLOBAL.NET';
default_global_info_filename     = 'GLOBAL.TXT';
default_conference_filename      = 'CONF.NET';
default_conference_info_filename = 'CONF.TXT';
default_bbs_filename             = 'BBS.NET';
default_backup_bbs_filename      = 'BBS.BAK';
default_nodelist_filename        = 'NODELIST';
compress_command                 = 'pkzip -a ';
max_conferences                  = 255;
max_bbses                        = 100;
max_sends                        = 50;
max_tcans                        = 10;
menux                            = 1;
menuy                            = 5;
maxlen                           = 80;

header_foreground                = lightred;
header_background                = black;
escape_foreground                = yellow;
escape_background                = black;
main_foreground                  = white;
main_background                  = black;
more_foreground                  = lightcyan;
more_background                  = black;
confirmation_foreground          = lightred;
confirmation_background          = black;
menu_header_foreground           = lightmagenta;
menu_header_background           = black;
save_prompt_foreground           = lightred;
save_prompt_background           = black;

{$i netmail.scr}                             (* opening screen *)





type

send_record_type                         = record
  send_file                              : string;
  send_bbs                               : array[1..max_sends] of string[8];
end; {record}

global_record_type   = record
    sysops_full_name                             : string[25];
    bbs_code                                     : string[8];
    user_file_path                               : string[25];
    work_dir                                     : string[25];
    file_dir                                     : string[25];
    comm_dir                                     : string[25];
    cnames_dir                                   : string[25];
    hub_indicator                                : char;
    verify_door_callers                          : char;
    days_old                                     : integer;
    send_indicator                               : char;
    max_bytes_in                                 : longint;
    disable_netdoor_from_hh                      : integer;
    disable_netdoor_from_mm                      : integer;
    disable_netdoor_to_hh                        : integer;
    disable_netdoor_to_mm                        : integer;
    tag_line                                     : string[60];
    node_hub_indicator                           : char;
    filler                                       : array[1..254] of char;
end; {record}


cnames_occurrence   = record
    conference_name                              : string[8];
    full_conference_filename                     : string[40];
    last_message_number_exported                 : real;
    network_indicator                            : char;
    max_messages_to_import                       : integer;
    stop_incoming_private                        : char;
    stop_outgoing_private                        : char;
    convert_incoming_private                     : char;
    convert_outgoing_private                     : char;
    echo_pcb_indicator                           : char;
    suppress_tag_use_indicator                   : char;
    echo_on_export_indicator                     : char;
    cnames_filler                                : char4;
end; {record}

work_sysops_name_type                            = char25;

msg_block_type   = record
  high_message_number                            : single;
  low_message_number                             : single;
  active_messages                                : single;
  callers                                        : single;
  lock_indicator                                 : char6;
  filler                                         : array[1..106] of char;
end; {record}





tag_line_type     = record
  init_char                                      : char;
  tag_prefix                                     : char11;
  tag                                            : array[1..60] of char;
  term_char                                      : char;
  filler                                         : array[1..55] of char;
end; {record}



bbs_confs_type        = record
  bbs_conf                           : string[8];
  bbs_last_message_processed         : single;
end; {record}

bbs_record_type  = record
  bbs_node_code                      : string[8];
  bbs_sysop_name                     : string[25];
  bbs_tag_line                       : string[60];
  bbs_hub_ind                        : char;
  bbs_last_called                    : string[8];
  bbs_conferences                    : array[1..max_conferences] of bbs_confs_type;
end; {record}




confinfo_record_type  = record
  confinfo_title                 : string[19];
  confinfo_filename              : string[31];
  confinfo_filler                : array[1..421] of char;
end; {record}


conf_array        = array[1..max_conferences] of cnames_occurrence;

const

cnames_ptr : ^conf_array = nil;



var

help_pointer        : helpptr;
screen_segment      : word;
bbs_count           : longint;
confinfo_record     : confinfo_record_type;
confinfo_file       : buffered_file;
bbs_records         : integer;
node_count          : integer;
textattr_hold       : byte;
hub                 : boolean;
count,subcount      : integer;
tcan_count          : integer;
tcan_present        : boolean;
work_sysops_name    : work_sysops_name_type;
send_record         : send_record_type;
command             : string;          (* command string passed to DOS *)
tag_line            : tag_line_type;
msg_file            : buffered_file;
msg_block           : msg_block_type;
times1,times2,t     : integer;         (* all purpose counter          *)
cnames_filename     : string;          (* full cnames filename         *)
send_file           : buffered_file;   (* send  "handle"               *)
cnames_file         : text;            (* cnames "handle"              *)
tcan_file           : buffered_file;   (* tcan   "handle"              *)
global_file         : buffered_file;   (* global "handle"              *)
conference_file     : buffered_file;   (* conference file "handle"     *)
bbs_file            : buffered_file;   (* bbs file "handle"            *)
backup_bbs_file     : buffered_file;   (* bbs file "handle"            *)
bbs_record          : bbs_record_type;
conference_count    : integer;         (* number of active conferences *)
conference_locked   : boolean;         (* is msg based LOCKED?         *)
dummy_string        : string;          (* all purpose string           *)
dummy_char          : char;            (* all purpose char             *)
dummy_word          : word;
dummy_int           : integer;         (* all purpose integer          *)
dummy_boolean       : boolean;
tcan_array          : array[1..max_tcans] of string[25];
global_record       : global_record_type;
x,tempx             : integer;
dummy_real          : real; 
y,startx,starty     : integer;
x1,x2,x3,x4,x5,x6,x7,x8,x8a,x9,x10,x11,x12,x13,x14,x15,x16,x17, 
y1,y2,y3,y4,y5,y6,y7,y8,y8a,y9,y10,y11,y12,y13,y14,y15,y16,y17 : byte;


term                : char;
return_to_main      : boolean;

{$i sortconf.inc}
{$i header.inc}                      (* header display       procedure *)
{$i escape.inc}                      (* escape prompt        procedure *)
{$i spaceout.inc}  
{$i movefile.inc}  
{$i validdir.inc}                    (* validate dir         function  *)
{$i save.inc}                        (* save changes prompt  procedure *)
{$i wait.inc}                        (* wait for key         procedure *)
{$i nodelist.inc}
{$i exec.inc}                        (* exec DOS command     procedure *)
{$i loadconf.inc}                    (* load conference file procedure *)
{$i loadglob.inc}                    (* load global file     procedure *)
{$i saveconf.inc}                    (* save conference file procedure *)
{$i resetbbs.inc}
{$i resconf.inc}                     (* reset single conf    procedure *)
{$i reset.inc}                       (* reset                procedure *)
{$i resingle.inc}                    (* prepare conf reset   procedure *)
{$i loadcnam.inc}                    (* load cnames file     procedure *)
{$i saveglob.inc}                    (* save global file     procedure *)
{$i addconf.inc}                     (* add conference entry procedure *)
{$i delconf.inc}                     (* delete conf entry    procedure *)
{$i addback.inc}                     (* add backslash        procedure *)
{$i showgent.inc}                    (* show global entries  procedure *)
{$i globsave.inc}
{$i editglob.inc}                    (* edit global info     procedure *)
{$i showcent.inc}                    (* show cnames entry    procedure *)
{$i editconf.inc}                    (* edit cconference fil procedure *)
{$i init.inc}                        (* initialization       procedure *)
{$i mvbbsin.inc}                     (* move bbs entries in  procedure *)
{$i term.inc}                        (* termination          procedure *) 
{$i bbsmaint.inc}                    (* Node maintenance     procedure *)
{$i miscfile.inc}      
{$i mainmenu.inc}                    (* main menu            procedure *)



Begin  {program}


initialize;                    (* display disclaimer, load config file, *)
                               (* verify command line.                  *)


mainmenu;

terminate;

end. {program}
