procedure determine_calling_node;


(* ----------------------------------------------------------------------- *)

Begin                                           { procedure }

check_carrier;

dummy_string := global_record.work_dir +
		'*.OUT';

findfirst(dummy_string,anyfile,noderec);

if doserror <> 0 then
begin
  dummy_string := system_date + ' ' + system_time +
		' Unable to Determine Caller BBS CODE.';
  make_log_entry(dummy_string,false);
  newline;
  displn('Cannot Find ".OUT" File in ' + global_record.work_dir);
  terminate;
end;

node_id := remove_ext(noderec.name);


make_log_entry(system_date + ' ' + system_time +
	      ' Caller Identified as ' + node_id,false);


if node_id = global_record.bbs_code then
begin
  make_log_entry(system_date + ' ' + system_time +
		' WARNING: NODE ID DUPLICATES HUB ID!',false);
  newline;
  displn('Warning: HUB System Operating With Identical BBS CODE!.');
  command := 'erase ' + global_record.work_dir + node_id + '.*';
  exec_program(command);
  terminate;
end;


end;    { determine calling node procedure }


