{$A+,D-,I-,L-,R-,S-,V-}
{$M 8000,0,1000}

Program Import;
Uses Dispedit,
     DOS,
     TPString,
     OpenShare,
     TPCrt,
     DosMem,
     MDosIO,
     BufIO,
     Tools,
     ErrTrap;

const

title                            =  'NETMail  4.3  ';
author                           = 'Copyright (c) 1989,90  Mark J. Findlay';
default_tcan_filename            = 'TCAN.NET';
decompress_command               = 'pkunzip -o ';
default_global_filename          = 'GLOBAL.NET';
default_national_nodelist_filename = 'NETWORK.LST';
default_conference_filename      = 'CONF.NET';
default_bbs_filename             = 'BBS.NET';
default_nodelist_filename        = 'NODELIST';
pcbndx_prefix                    = 'PCBNDX';
default_names_filename           = 'NAMES.NET';
default_tags_filename            = 'TAGS.NET';
sysop_constant                   = 'SYSOP                    ';


live_message                     = #225;
recbufs                          = 400;
max_blocks_in_message            = 70;
max_conferences                  = 255;
max_tcans                        = 10;
max_sends                        = 50;
maxindexes                       = 8192;
maxusers                         = 10000;
max_names                        = 100;
max_tags                         = 10;

header_foreground                = lightred;
header_background                = black;
escape_foreground                = yellow;
escape_background                = black;
main_foreground                  = white;
main_background                  = black;
confirmation_foreground          = lightred;
confirmation_background          = black;
menu_header_foreground           = lightmagenta;
menu_header_background           = black;
save_prompt_foreground           = lightred;
save_prompt_background           = black;


(* _________________________________________________________________ *)

type
index_array          = array[1..maxindexes] of single;

crc_array_type       = record
    crc                                          : word;
    crc_msg_number                               : single;
end; {record}

crc_array            = array[1..maxindexes] of crc_array_type;

user_array           = array[1..maxusers] of word;


io_array_type        = record
    status_code                                  : char;
    message_number                               : single;
    refer_to                                     : single;
    blocks                                       : byte;
    date                                         : char8; {mm-dd-yy}
    time                                         : char5; {hh:mm}
    whoto                                        : char25;
    readdate                                     : single;
    readtime                                     : char5;
    hasreplys                                    : char;
    whofrom                                      : char25;
    subject                                      : char25;
    password                                     : char12;
    status                                       : char; {live=225}
    echoflag                                     : char; {E=Echo}
    filler                                       : char6;
end; {record}


io_array              = array [1..max_blocks_in_message] of io_array_type;


const

index_pointer:                   ^index_array = nil;   (* index pointer *)
crc_pointer:                     ^crc_array   = nil;
io_pointer:                      ^io_array    = nil;
user_pointer:                    ^user_array  = nil;


(* _________________________________________________________________ *)



type


tag_line_type        = record
    init_char                                    : char;
    tag_prefix                                   : char11;
    tag                                          : array[1..60] of char;
    term_char                                    : char;
    filler                                       : array[1..55] of char;
end; {record}


msg_block_type       = record
    high_message_number                          : single;
    low_message_number                           : single;
    active_messages                              : single;
    callers                                      : single;
    lock_indicator                               : char6;
    filler                                       : array[1..106] of char;
end; {record}

refer_crc_type       = record
    fillx                                        : char;
    filly                                        : single;
    refno       {corresponds with refer_to}      : word;
end; {record}


global_record_type   = record
    sysops_full_name                             : string[25];
    bbs_code                                     : string[8];
    user_file_path                               : string[25];
    work_dir                                     : string[25];
    file_dir                                     : string[25];
    comm_dir                                     : string[25];
    cnames_dir                                   : string[25];
    hub_indicator                                : char;
    verify_door_callers                          : char;
    days_old                                     : integer;
    send_indicator                               : char;
    max_bytes_in                                 : longint;
    disable_netdoor_from_hh                      : integer;
    disable_netdoor_from_mm                      : integer;
    disable_netdoor_to_hh                        : integer;
    disable_netdoor_to_mm                        : integer;
    tag_line                                     : string[60];
    node_hub_indicator                           : char;
    filler                                       : array[1..254] of char;
end; {record}


cnames_occurrence   = record
    conference_name                              : string[8];
    full_conference_filename                     : string[40];
    last_message_number_exported                 : real;
    network_indicator                            : char;
    max_messages_to_import                       : integer;
    stop_incoming_private                        : char;
    stop_outgoing_private                        : char;
    convert_incoming_private                     : char;
    convert_outgoing_private                     : char;
    echo_pcb_indicator                           : char;
    suppress_tag_use_indicator                   : char;
    echo_on_export_indicator                     : char;
    filler                                       : array[1..4] of char;
end; {record}

bbs_record_type  = record
    node_code                                    : string[8];
    conferences_carried                          : array[1..max_conferences] of char;
    filler                                       : array[1..15] of char;
end; {record}

work_sysops_name_type                            = char25;


pcbndx_record_type = record
  pcbndx_filler      : word;
  pcbndx_name        : char25;
end; {record}



var


node_only           : boolean;
echoes_only         : boolean;
message_direction_in_effect : boolean;
user_count          : integer;
pcbndx_record       : pcbndx_record_type;
pcbndx_file         : buffered_file;
noderec             : searchrec;
crc_size                     : word;
last_message_number_imported : single;
pcbndx_name_size          : word;
whofrom_subject_size      : word;
starting_block_of_msg : word;
msg_block_size  : word;
date_time_whoto_size : word;
duplicate_message   : boolean;
refer_to_found      : boolean;
crc_count           : longint;
textattr_hold       : byte;
display_char        : char8;
index_used          : real;
index_calculated    : boolean;
report_written      : boolean;
fill_incomplete     : boolean;
fill_line           : boolean;
no_messages_in_base : boolean;
hub                 : boolean;
count               : integer;
import_in_progress  : boolean;
tcan_count          : integer;
tcan_present        : boolean;
work_sysops_name    : work_sysops_name_type;
msg_counter         : integer;
command             : string;          (* command string passed to DOS *)
tag_line            : tag_line_type;   (* tag line written             *)
times1,times2       : integer;         (* all purpose counter          *)
index_file          : dos_handle;      (* index "handle"               *)
index_filename      : dos_filename;    (* index filename handle        *)
index_size          : longint;
index_count         : longint;
report_file         : text;
log_file            : text;            (* report file handle           *)
tcan_file           : text;            (* tcan   "handle"              *)
global_file         : buffered_file;   (* global "handle"              *)
input_msg_filename  : string;          (* input  message file name     *)
input_msg_file      : buffered_file;   (* input  msg file handle       *)
conference_file     : buffered_file;   (* conference file "handle"     *)
bbs_file            : buffered_file;   (* bbs file "handle"            *)
conference_count    : integer;         (* number of active conferences *)
conference_locked   : boolean;         (* is msg based LOCKED?         *)
refer_crc           : word;
msg_file            : buffered_file;   (* msg file "handle"            *)
dummy_real          : real;            (* all purpose real             *)
dummy_string        : string;          (* all purpose string           *)
dummy_int           : integer;         (* all purpose integer          *)
cnames_array        : array[1..max_conferences] of cnames_occurrence;
tcan_array          : array[1..max_tcans] of string[25];
bbs_record          : bbs_record_type;
global_record       : global_record_type;
msg_block           : msg_block_type;
x3,x,y,a,b,c,d      : integer;
return_to_main      : boolean;
names_found         : boolean;
names_array         : array[1..max_names] of word;
names_count         : integer;
tags_found          : boolean;
tags_count          : integer;
tags_array          : array[1..max_tags] of string[25];
log_file_open       : boolean;
logging_in_effect   : boolean;
dummy_word          : word;



{$i upchar.inc}
{$i setcrc.inc}
{$i makelog.inc}
{$i loadtags.inc}
{$i crc16.inc}                       (* crc calc             procedure *)
{$i loadname.inc}
{$i header.inc}                      (* header display       procedure *)
{$i addback.inc}
{$i cleardir.inc}
{$i movefile.inc}
{$i loaduser.inc}
{$i exec.inc}                        (* exec DOS command     procedure *)
{$i replbad.inc}                     (* replace bad words    procedure *)
{$i loadtcan.inc}                    (* load tcan file       procedure *)
{$i validate.inc}                    (* validate net files   procedure *)
{$i readimp.inc}                     (* read/import messages procedure *)
{$i loadglob.inc}                    (* load global file     procedure *)
{$i closindx.inc}                    (* close index file     procedure *)
{$i openindx.inc}                    (* open index file      procedure *)
{$i openmsg.inc}                     (* open message file    procedure *)
{$i saveconf.inc}                    (* save conference file procedure *)
{$i init.inc}                        (* initialization       procedure *)
{$i loadconf.inc}                    (* load conference file procedure *)
{$i uplast.inc}                      (* upd last msg processed         *)
{$i loadcrc.inc}                     (* load crc table       procedure *)
{$i impconf.inc}                     (* import conference    procedure *)
{$i import.inc}                      (* import               procedure *)




Begin  {program}


initialize;                    (* display disclaimer, load config file, *)
			       (* verify command line.                  *)


Import_mail;


end. {program}
